void slave() {
  double speed, dist, dist_l, dist_r;
  double photo_c;
  run_state_t state;
  command_data_t command_data;

  while (1) {
    if (raspi_receive(&command_data) == 0) {
      
      switch (command_data.val[0]) {
        case 1:
          run_ctrl_set(STP, 0, 0);
          break;
        case 2:
          run_ctrl_set(STR, command_data.val[1], command_data.val[2]);
          break;
        case 3:
          run_ctrl_set(ROT, command_data.val[1], command_data.val[2]);
          break;
        case 10:
          run_ctrl_get(&state, &speed, &dist);
          command_data.val[0] = ((state == STR) ? 2 : (state == ROT) ? 3 : 1);
          command_data.val[1] = (short)speed;
          command_data.val[2] = (short)dist;
          raspi_send(command_data);
          break;
        case 11:
          distance_get(&dist_l, &dist_r);
          command_data.val[0] = (short)dist_l;
          command_data.val[1] = (short)dist_r;
          raspi_send(command_data);
          break;
        case 12:
          command_data.val[0] = (short)(io_get_batt() * 100.0);
          raspi_send(command_data);
          break;
        case 20:
          led(command_data.val[1]);
          break;
        case 61:
          command_data.val[0] = photo(0);
          command_data.val[1] = photo(1);
          command_data.val[2] = photo(2);
          raspi_send(command_data);
          break;
        case 70:
          run_ctrl_set(LINE, command_data.val[1], command_data.val[2]);
          break;
        case 100:
          servo();
          break;
        case 101:
          cap_photo(&photo_c);
          command_data.val[0] = (int)photo_c %1000000 / 10000;
          command_data.val[1] = (int)photo_c %10000 / 100;
          command_data.val[2] = (int)photo_c %100;
          raspi_send(command_data);
          break;
        case 641:
          command_data.val[0] = 6;
          command_data.val[1] = 4;
          command_data.val[2] = 1;
          //Serial.println("koutyan!");
          raspi_send(command_data);
          break;
        default:
          break;
      }
    }
    run_ctrl_execute();
    vel_ctrl_execute();
    delay(T_CTRL);
  }
}

