# color.py

import time
import board
import busio
import adafruit_tcs34725

def get_color_info():
    # I2Cバスの初期化
    i2c = busio.I2C(board.SCL, board.SDA)

    # TCS34725センサーの初期化
    sensor = adafruit_tcs34725.TCS34725(i2c)

    # 色、温度、照度の情報を取得
    color_rgb = sensor.color_rgb_bytes
    temperature = sensor.color_temperature
    lux = sensor.lux

    # RGB値を取得
    r, g, b = color_rgb

    # 色情報を表示
    color_str = f'Color: \x1b[38;2;{r};{g};{b}m█\x1b[0m'
    print(color_str)
    # print(f'Temperature: {temperature}K')
    print(f'R:{r}, G:{g}, B:{b}, Lux: {lux}')

    # RGB値をファイルに書き込む
    with open("rgb_values.txt", "w") as file:
        file.write(f"{r} {g} {b} {lux}")

# 0.5秒待つ
time.sleep(0.2)

# 関数呼び出し
get_color_info()
