#ifndef __ARM__
#define __ARM__

typedef struct{
	unsigned char val[7];
} serial_data_arm;

typedef struct{
	unsigned char val[6];
} middle_data_arm;

typedef struct{
	signed short val[3];
} command_data_arm;

extern int  arduino_arm_open();
extern void arduino_arm_close();
extern void arduino_arm_clear();

extern int  arduino_arm_read(serial_data_arm *serial_data);
extern void arduino_arm_write(serial_data_arm serial_data);

extern int  arduino_arm_receive(command_data_arm *command_data);
extern void arduino_arm_send(command_data_arm command_data);

extern middle_data_arm  arduino_arm_decode1(serial_data_arm serial_data);
extern command_data_arm arduino_arm_decode2(middle_data_arm middle_data);
extern serial_data_arm  arduino_arm_encode1(middle_data_arm middle_data);
extern middle_data_arm  arduino_arm_encode2(command_data_arm command_data);

extern void osu(int mode);

#endif
