#ifndef __REQUEST__
#define __REQUEST__

typedef enum{
	STP = 0,
	STR,
	ROT,
	LINE
} run_state_t;

typedef enum{
	OK,
	NG,
	PAS,
	RUN,
	THR
} led_state_t;

extern void request_set_runmode(run_state_t state, int speed, int dist);
extern int  request_get_runmode(run_state_t *state, int *speed, int *dist);
extern int  request_get_dist(int *dist_l, int *dist_r);
extern int  request_get_batt(double *volt);

//フォトリフレクタ用
extern int photo(int *ph0, int *ph1, int *ph2);

/*サーボモータ用*/
extern void request_set_servo();

/*capフォトリフレクタ用*/
extern int cap_photo(int *cap_photo);

/*LED用*/
extern void request_set_led(led_state_t state, int red, int green);

//ライントレース
extern void linetrace(int speed, int dist);

#endif
