#include "callback.h"
#include "arduino.h"
#include "request.h"

void buttonInterrupt() {
    printf("GPIO CALL BACK!\n");
    request_set_runmode(STP, 0, 0);
    usleep(50 * 1000);
    arduino_close();
    exit(0);//プログラムを終了させる
}

int callback_set() {
    // WiringPi ライブラリを初期化
    if (wiringPiSetup() == -1) {
        fprintf(stderr, "Unable to initialize WiringPi\n");
        return -1;
    }
    // ピンモードを入力に設定
    pinMode(CALLBACK_PIN, INPUT);
    // プルアップ抵抗を有効化
    pullUpDnControl(CALLBACK_PIN, PUD_UP);
    // 外部割り込みをセットアップ
    wiringPiISR(CALLBACK_PIN, INT_EDGE_FALLING, &buttonInterrupt);
    printf("initialize WiringPi\n");
    return 0;
}
