#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include "arduino.h"
#include "io.h"
#include "request.h"
#include "uss.h"
#include "pilot.h"
#include "arm.h"

void elev(int mode){
    run_state_t state;
    int uss_l, uss_r, speed, deg, dist;
    int count = 0;
    
    const int speed_set = 30;
    const int deg_set = -90;

    const int back_kyori = -20;//ボタンを押して下がる距離
    const int hidari = 55;//ボタンを押した後、横に進む距離
    const int elev_kyori = 130;//エレベーターが開いたかどうか
    const int elve_str = 130;

    
    int wall_kyori = 50;//最初の位置

    posi();

    int sw = 1;

    arduino_arm_open();

    while(1){
        io_get_sw(&sw);//タッチセンサの値を取得
        printf("switch = %d\n", sw);
                
        osu(1);
        sleep(3);
        osu(2);

	    usleep(100 * 1000);

        if(sw == 0){//タッチセンサが押されたらループを出る
            break;
        }
    }

    //arm(mode);

    //下がる
    speed = speed_set;
    dist = back_kyori;
    request_set_runmode(STR, speed, dist);
	while(1){
		request_get_runmode(&state, &speed, &deg);
		if( state == STP ) break;
	}

    //左に回転する
    speed = speed_set*2;
    deg = deg_set;
    request_set_runmode(ROT, speed, deg);
	while(1){
		request_get_runmode(&state, &speed, &deg);
		if( state == STP ) break;
	}

    //直進する
    speed = speed_set;
    dist = hidari;
    request_set_runmode(STR, speed, dist);
    while(1){
		request_get_runmode(&state, &speed, &dist);
		if( state == STP ) break;
	}

    //右に回転する
    speed = speed_set*2;
    deg = -deg_set;
    request_set_runmode(ROT, speed, deg);
	while(1){
		request_get_runmode(&state, &speed, &deg);
		if( state == STP ) break;
	}

    //エレベーターが開いたか検知する
    count = 0;
    while(1){
        uss_l = uss_get_l();		
        uss_r = uss_get_r();
        printf("uss_l = %d, uss_r = %d\n", uss_l, uss_r);
        usleep(10 * 1000);

        //エレベーターが開いたらループを抜け出す
        if((uss_l > elev_kyori || uss_l < 0) && (uss_r > elev_kyori || uss_r < 0)){
            count++;
        }
        if(count >= 10){
            break;
        }
    }

    //エレベーターに乗る
    speed = speed_set;
    dist = elve_str;
    request_set_runmode(STR, speed, dist);
    while(1){
		request_get_runmode(&state, &speed, &deg);
		if( state == STP ) break;
    }

    //入り口の方を見る
    speed = speed_set*2;
    deg = deg_set*2;
    request_set_runmode(ROT, speed, deg);
	while(1){
		request_get_runmode(&state, &speed, &deg);
		if( state == STP ) break;
	}

    while(1){
        system("aplay speak/elev.wav");
        sleep(2);
    }

    //階を押す
    arm(mode+100);


    //エレベーターを降りる
    while(uss_l < elev_kyori || uss_l > 0 || uss_r < elev_kyori || uss_r > 0){
        uss_l = uss_get_l();		
        uss_r = uss_get_r();
        printf("uss_l = %d, uss_r = %d\n", uss_l, uss_r);
        usleep(10 * 1000);
    }
    
    request_set_runmode(STR, speed, 100);
    while(uss_l < wall_kyori || uss_l > 0 || uss_r < wall_kyori || uss_r > 0){
        uss_l = uss_get_l();		
        uss_r = uss_get_r();
        printf("uss_l = %d, uss_r = %d\n", uss_l, uss_r);
        usleep(10 * 1000);
    }
    request_set_runmode(STP, 0, 0);


}
