#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "pilot.h"
#include "arduino.h"
#include "arm.h"
#include "io.h"
#include "callback.h"
#include "input.h"
#include "status.h"

int main(){
    int sw;

    if(arduino_arm_open() != 0){
        printf("armが正常にセットアップ出来ませんでした。\n");
        //return -1;
    }
    if(io_open() != 0){
        printf("タッチセンサが正常にセットアップ出来ませんでした。\n");
        return -1;
    }
    if(callback_set() != 0){
        printf("強制停止ボタンが正常にセットアップ出来ませんでした。\n");
        return -1;
    }
    if(arduino_open() != 0){
        printf("Arduinoが正常にセットアップできませんでした。\n");
        return -1;
    }
    if(color_set() != 0){
        printf("カラーセンサが正常にセットアップ出来ませんでした。\n");
        return -1;
    }

    sleep(1);

    int pet_state = 0, cap_state = 0;
    int photo0, photo, photo_d;
    photo0 = 1000;
    int yowai_frag = 0;
    int i=0;
    int capa=0;
    usleep(2000 * 1000);

    while(1){
        cap_photo(&photo);
        photo_d = photo - photo0;
        printf("photo : %d\n", photo);
        printf("photo_d : %d\n", photo_d);

        io_get_sw(&sw); // タッチセンサの値を取得
        if(sw == 0){ // タッチセンサが押されたらアームを動かす
            printf("armを動かします。\n");

            osu(10);
            sleep(3);
            osu(2);
            sleep(2);
        }

        if (photo_d > 30){
            cap_state = 1;
        }else if (photo_d < -30){
            cap_state = 0;
        }

        if (photo == 1023){
            cap_state = 1;
            yowai_frag = 1;
        }
        else if(photo != 1023 && yowai_frag == 1){
            cap_state = 0;
            yowai_frag = 0;
        }

        pet_state = water_input(); //(lux > 500)

        if (pet_state == 0 && cap_state == 0){
            /*投入されるのを待っている時の処理*/
        }
        else if (pet_state == 1 && cap_state == 0){
            /*キャップをセットしてね*/
            speak(cap_speak);
        }
        else if (pet_state == 0 && cap_state == 1)
        {
            /*ペットボトルを入れてね*/
            speak(accept_speak);
        }
        else if (pet_state == 1 && cap_state == 1){
            if (water() == 0){
                pass(); // モータを動かす
                led(gre_fla);
                led(gre_fla);
                /*リサイクルありがとう！*/
                speak(thank_speak);
                capa++;
                printf("capa : %d\n", capa);
                if(capa>=27){
                    printf("ゴミがいっぱいです\n");
                    while(1){
                        led(red_fla);
                        sleep(5);
                    }
                }
                usleep(2000 * 1000);
            }else{
                /*ペットボトルの分別ができていないよ*/
                speak(bunbetsu_speak);
            }
        }
        photo0 = photo;
        if(i == 60){//定期的にArduinoを開き直す
            i = 0;
            if(arduino_open() != 0){
                printf("Arduinoが正常にセットアップできませんでした。\n");
                while(1){
                    led(red_fla);
                    sleep(5);
                }
            }
            sleep(1);
        }
        i++;
        usleep(500 * 1000);
    }

    arduino_close();
    arduino_arm_close();
    return 0;
}
