#include <stdio.h>
#include <unistd.h>
#include "arduino.h"
#include "io.h"
#include "request.h"
#include "uss.h"
#include "pilot.h"
#include "input.h"
#include "status.h"
#include "callback.h"
#include "arm.h"

int main(){

	int capa=25;//ペットボトルの入る最大量
	
	if(callback_set() != 0){
		printf("強制停止ボタンが正常にセットアップ出来ませんでした。\n");
		return -1;
	}
	if(arduino_open() != 0){
		printf("Arduinoが正常にセットアップ出来ませんでした。\n");
		return -1;
	}
	if(uss_open_l() != 0){
		printf("左前の超音波センサが正常にセットアップ出来ませんでした。\n");
		return -1;
	}
	if(uss_open_r() != 0){
		printf("右前の超音波センサが正常にセットアップ出来ませんでした。\n");
		return -1;
	}
	if(uss_open_hidari() != 0){
		printf("左の超音波センサが正常にセットアップ出来ませんでした。\n");
		return -1;
	}
	if(uss_open_migi() != 0){
		printf("右の超音波センサが正常にセットアップ出来ませんでした。\n");
		return -1;
	}
	if(io_open() != 0){
		printf("タッチセンサが正常にセットアップ出来ませんでした。\n");
		return -1;
	}
	if(arduino_arm_open() != 0){
		printf("armが正常にセットアップ出来ませんでした。\n");
		return -1;
	}
	if(color_set() != 0){
		printf("カラーセンサ用のLEDが正常にセットアップできませんでした。\n");
		return -1;
	}
	printf("\n");
	
	double vcc;
	if(request_get_batt(&vcc) != 0) {
		printf("request_get_batt error\n");
		//return -1;
	}
	printf("Vcc : %3.2lf\n", vcc);
	
	//処理実行
	printf("press enter to start\n");
	getchar();
	
	//処理スタート
	while(1){
		for(int i=1; i<=capa; i++){//ペットボトルの数が最大数になるまで繰り返す
			input();
			printf("現在は %d本 入っています\n",i);
		}
		printf("%d本 投入されたため移動します\n",capa);
		run();
	}
	
	arduino_close();
	return 0;
}
