#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "arduino.h"
#include "request.h"
//#include "arm.h"

void request_set_runmode(run_state_t state, int speed, int dist){
	command_data_t command_data;
	
	command_data.val[0] = ((state == STR) ? 2 : (state == ROT) ? 3 : 1);
	command_data.val[1] = speed;
	command_data.val[2] = dist;/*230707:mainasu_tuketa*/
	
	arduino_send(command_data);
}

int request_get_runmode(run_state_t *state, int *speed, int *dist){
	command_data_t command_data;
	
	command_data.val[0] = 10;
	command_data.val[1] = 0;
	command_data.val[2] = 0;
	
	arduino_clear();
	arduino_send(command_data);
	usleep(50 * 1000);
	
	if(arduino_receive(&command_data) == 0){
		*state = ((command_data.val[0] == 2) ? STR : (command_data.val[0] == 3) ? ROT : STP);
		*speed = command_data.val[1];
		*dist  = command_data.val[2];//1 -> 2 ni henkou
		//printf("%d\n",command_data.val[2]);
		return 0;
	}else{
		return -1;
	}
}

int request_get_dist(int *dist_l, int *dist_r){
	command_data_t command_data;
	
	command_data.val[0] = 11;
	command_data.val[1] = 0;
	command_data.val[2] = 0;
	
	arduino_clear();
	arduino_send(command_data);
	usleep(50 * 1000);
	
	if(arduino_receive(&command_data) == 0){
		*dist_l = command_data.val[0];
		*dist_r = command_data.val[1];
		return 0;
	}else{
		return -1;
	}
}

int request_get_batt(double *volt){
	command_data_t command_data;
	
	command_data.val[0] = 12;
	command_data.val[1] = 0;
	command_data.val[2] = 0;
	
	arduino_clear();
	arduino_send(command_data);
	usleep(50 * 1000);
	
	if(arduino_receive(&command_data) == 0){
		*volt = command_data.val[0] / 100.0;
		return 0;
	}else{
		return -1;
	}
}

int photo(int *ph0, int *ph1, int *ph2){
	command_data_t command_data;
	
	command_data.val[0] = 61;
	command_data.val[1] = 0;
	command_data.val[2] = 0;
	
	arduino_clear();
	arduino_send(command_data);
	usleep(50 * 1000);
	
	if(arduino_receive(&command_data) == 0){
		*ph0 = command_data.val[0];
		*ph1 = command_data.val[1];
		*ph2 = command_data.val[2];
		return 0;
	}else{
		return -1;
	}
}

/*サーボモータ用*/
void request_set_servo(){
	command_data_t command_data;
	
	command_data.val[0] = 100;
	command_data.val[1] = 0;
	command_data.val[2] = 0;
	
	arduino_clear();
	arduino_send(command_data);
}

/*capフォトリフレクタ用*/
int cap_photo(int *cap_photo){
	command_data_t command_data;
	
	command_data.val[0] = 101;
	command_data.val[1] = 0;
	command_data.val[2] = 0;
	
	arduino_clear();
	arduino_send(command_data);
	usleep(50 * 1000);
	
	if(arduino_receive(&command_data) == 0){
		int photo3 = command_data.val[0];
		int photo2 = command_data.val[1];
		int photo1 = command_data.val[2];
		*cap_photo = photo3*10000 + photo2*100 + photo1;
		return 0;
	}else{
		return -1;
	}
}

/*LED用*/
void request_set_led(led_state_t state, int red, int green){
		command_data_t command_data;

		command_data.val[0] = 20;

		if(state == OK){
			command_data.val[1] = 21;
		}
		else if(state == NG){
			command_data.val[1] = 22;
		}
		else if(state == PAS){
			command_data.val[1] = 23;
		}
		else if(state == RUN){
			command_data.val[1] = 24;
		}
		else if(state == THR){
			command_data.val[1] = 25;
		}
		else{
			command_data.val[1] = 26;
		}
		
		command_data.val[2] = 0;
		
		arduino_send(command_data);
	}

//ライントレース用
void linetrace(int speed, int dist){
	command_data_t command_data;
	
	command_data.val[0] = 70;
	command_data.val[1] = speed;
	command_data.val[2] = dist;
	
	arduino_clear();
	arduino_send(command_data);
}
