#include <stdio.h>
#include <unistd.h>
#include "io.h"
#include "request.h"
#include "uss.h"
#include "pilot.h"
#include "status.h"

static const int speed_set = 30;//移動速度[cm/s]
static const int deg_set = -88;//回転角度[deg]
static const int stop_kyori = 100;//止まるときの距離[cm]

static const int stt0 = 120;//ゴミ捨て階での直進距離[cm]
static const int stt1 = 300;
static const int stt2 = 100;
    
static const int stc0 = 130;
static const int stc1 = 320;
static const int stc2 = 150;

void going();
void come();
void avoid(int dist_hoji);

void run(){
    int sw;

    status(run_status);//状態表示(走行)
    going();//行き

    status(input_status);//状態表示(ゴミ捨て)

    while(1){
		io_get_sw(&sw);//タッチセンサの値を取得
		printf("switch = %d\n", sw);
        if(sw == 0){
            break;//タッチセンサが押されたらループを抜け出す
        }
		usleep(100 * 1000);
	}

    status(run_status);//状態表示(走行)
    come();//帰り
}

void going(){
    run_state_t state;
    int speed, deg, dist;
    //int dist_hoji = 0;
    

    //直進
    printf("直進します\n");
    speed = speed_set;
    dist = stc0;
    //dist_hoji = stc0;
    request_set_runmode(STR, speed, dist);

    avoid(stc0);
    
    request_set_runmode(STP, 0, 0);
    usleep(500*1000);

	//90度左に回転
    printf("回転します\n");
    speed = speed_set*2;
    deg = deg_set;
    request_set_runmode(ROT, speed, deg);
    
	while(io_gt){
		request_get_runmode(&state, &speed, &deg);
        printf("dist = %d, speed = %d\n",deg, speed);
		if( state == STP ) break;
	}
    
    request_set_runmode(STP, 0, 0);
    usleep(500*1000);

	//直進
    printf("直進します\n");
    speed = speed_set;
    dist = stc1;
    request_set_runmode(STR, speed, dist);

    avoid(stc1);
    
    request_set_runmode(STP, 0, 0);
    usleep(500*1000);

	//90度左に回転
    printf("回転します\n");
	speed = speed_set*2;
	deg = deg_set;
	request_set_runmode(ROT, speed, deg);
    
	while(io_gt){
		request_get_runmode(&state, &speed, &deg);
        printf("dist = %d, speed = %d\n",deg, speed);
		if( state == STP ) break;
	}
    
    request_set_runmode(STP, 0, 0);
    usleep(500*1000);

	//直進
    printf("直進します\n");
    speed = speed_set;
    dist = stc2;
    request_set_runmode(STR, speed, dist);

    avoid(stc2);

    request_set_runmode(STP, 0, 0);
    usleep(500*1000);	



    





    elev(1);//エレベーターで降りる


    //90度左に回転
    printf("回転します\n");
    speed = speed_set*2;
    deg = deg_set;
    request_set_runmode(ROT, speed, deg);
    
	while(io_gt){
		request_get_runmode(&state, &speed, &deg);
        printf("dist = %d, speed = %d\n",deg, speed);
		if( state == STP ) break;
	}
    
    request_set_runmode(STP, 0, 0);
    usleep(500*1000);

    //直進
    printf("直進します\n");
    speed = speed_set;
    dist = stt1;
    request_set_runmode(STR, speed, dist);

    avoid(stt1);
   
    request_set_runmode(STP, 0, 0);
    usleep(500*1000);

    //90度左に回転
    printf("回転します\n");
    speed = speed_set*2;
    deg = deg_set;
    request_set_runmode(ROT, speed, deg);
    
	while(io_gt){
		request_get_runmode(&state, &speed, &deg);
		if( state == STP ) break;
	}
    
    request_set_runmode(STP, 0, 0);
    usleep(500*1000);

    //直進
    printf("直進します\n");
    speed = speed_set;
    dist = stt2;
    request_set_runmode(STR, speed, dist);
	
    avoid(stt2);

    request_set_runmode(STP, 0, 0);
    usleep(500*1000);
}

void come(){
    run_state_t state;
    int speed, deg, dist;


    //直進
    printf("直進します\n");
    speed = speed_set;
    dist = stt2;
    request_set_runmode(STR, speed, dist);

    avoid(stt2);

    request_set_runmode(STP, 0, 0);
    usleep(500*1000);

    //90度右に回転
    printf("回転します\n");
    speed = speed_set*2;
    deg = deg_set;
    request_set_runmode(ROT, speed, deg);
    
	while(io_gt){
		request_get_runmode(&state, &speed, &deg);
		if( state == STP ) break;
	}
    
    request_set_runmode(STP, 0, 0);
    usleep(500*1000);

    //直進
    printf("直進します\n");
    speed = speed_set;
    dist = stt1;
    request_set_runmode(STR, speed, dist);

    avoid(stt1);
 
    request_set_runmode(STP, 0, 0);
    usleep(500*1000);

    //90度右に回転
    printf("回転します\n");
    speed = speed_set*2;
    deg = deg_set;
    request_set_runmode(ROT, speed, deg);
    
	while(io_gt()){
		request_get_runmode(&state, &speed, &deg);
        printf("dist = %d, speed = %d\n",deg, speed);
		if( state == STP ) break;
	}
    
    request_set_runmode(STP, 0, 0);
    usleep(500*1000);

    //直進
    printf("直進します\n");
    speed = speed_set;
    dist = stt0;
    request_set_runmode(STR, speed, dist);

	avoid(stt0);

    request_set_runmode(STP, 0, 0);
    usleep(500*1000);

    elev(2);//エレベーターで上る
    
    //直進
    printf("直進します\n");
    speed = speed_set;
    dist = stc2;
    request_set_runmode(STR, speed, dist);

    avoid(stc2);
 
    request_set_runmode(STP, 0, 0);
    usleep(500*1000);
    
    //90度右に回転
    speed = speed_set*2;
    deg = deg_set;
    request_set_runmode(ROT, speed, deg);
	while(io_gt){
		request_get_runmode(&state, &speed, &deg);
		if( state == STP ) break;
	}
    
    request_set_runmode(STP, 0, 0);
    usleep(500*1000);
    
    //直進
    speed = speed_set;
    dist = stc1;
    request_set_runmode(STR, speed, dist);

    avoid(stc1);

    request_set_runmode(STP, 0, 0);
    usleep(500*1000);
    
    //90度右に回転
    speed = speed_set*2;
    deg = deg_set;
    request_set_runmode(ROT, speed, deg);
	while(io_gt){
		request_get_runmode(&state, &speed, &deg);
		if( state == STP ) break;
	}
    
    request_set_runmode(STP, 0, 0);
    usleep(500*1000);
    
    //直進
    speed = speed_set;
    dist = stc0;
    request_set_runmode(STR, speed, dist);

    avoid(stc0);
	
    request_set_runmode(STP, 0, 0);
    usleep(500*1000);
    
    //90度右に回転
    speed = speed_set*2;
    deg = deg_set;
    request_set_runmode(ROT, speed, deg);
	while(io_gt){
		request_get_runmode(&state, &speed, &deg);
		if( state == STP ) break;
	}
    
    request_set_runmode(STP, 0, 0);
    usleep(500*1000);
}


//超音波センサで回避するプログラム
//引数は進みたい距離を入れる
void avoid(int dist_hoji){
    run_state_t state;
    int uss_l, uss_r, speed, dist;
    int count = 0;
    float stop_time = 1.0;//障害物の判定時間[sec]
    const int ratio = 10;//減衰を開始する距離[cm]
    
    stop_time *= 10;

    while(io_gt()){
        uss_l = uss_get_l();		
        uss_r = uss_get_r();
        usleep(10 * 1000);
        request_get_runmode(&state, &speed, &dist);
        printf("uss_l = %d, uss_r = %d, dist = %d, speed = %d\n", uss_l, uss_r, dist, speed);

        //目標距離進んだら止まる
        if( state == STP ){
            printf("state = %d\n", state);
            break;
        }
          
        //障害物があったら止まる
        if((uss_l < stop_kyori || uss_r < stop_kyori) && uss_l > 0 && uss_r > 0){
            
            /*dist_hoji -= dist;//残りの距離を計算
            dist_hoji -= ratio;
                        
            printf("stop\n");
            
            state = STR;
            speed = speed_set;
            dist = ratio;
            request_set_runmode(state, speed, dist);
            while(io_gt()){
				request_get_runmode(&state, &speed, &dist);
				if( state == STP ) break;
			}*/

            dist_hoji -= dist;

            printf("stop\n");
            request_set_runmode(STP, 0, 0); 

			//ペットボトル運搬中です
            speak(carry_speak);

            while(io_gt()){
                uss_l = uss_get_l();		
                uss_r = uss_get_r();
                printf("uss_l = %d, uss_r = %d, count = %d\n", uss_l, uss_r, count);

				//障害物がなければカウントを増やす。障害物があればカウントを0にする
                if((uss_l > stop_kyori || uss_l < 0) && (uss_r > stop_kyori || uss_r < 0)){
                    count++;
                }else{
                    count = 0;
                }

				//カウントが規定値より大きくなったら走行を再開する
                if(count >= stop_time){
                    speed = speed_set;
                    dist = dist_hoji;
                    if(dist <= 0){
                        dist = 0;
                    }
                    state = STR;
                    request_set_runmode(state, speed, dist);
                    printf("break  dist = %d\n", dist);
                    break;
                }
                usleep(100*1000);
            }
        }
    }
    request_set_runmode(STP, 0, 0);
    sleep(1);
}
