#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "pilot.h"
#include "arduino.h"
#include "arm.h"
#include "io.h"
#include "callback.h"

int main(){
    int sw;
    
    if(arduino_arm_open() != 0){
	printf("armが正常にセットアップ出来ませんでした。\n");
	return -1;
    }
    if(io_open() != 0){
        printf("タッチセンサが正常にセットアップ出来ませんでした。\n");
        return -1;
    }
    if(callback_set() != 0){
    	printf("強制停止ボタンが正常にセットアップ出来ませんでした。\n");
    	return -1;
    }


    sleep(1);

    while(1){
	io_get_sw(&sw);//タッチセンサの値を取得
	printf("switch = %d\n", sw);

        if(sw == 0){//タッチセンサが押されたらアームを動かす
            printf("armを動かします。\n");
            
            osu(1);
            sleep(3);
            osu(2);
        }
	usleep(100 * 1000);
    }
	
    arduino_arm_close();
    return 0;
}
