#include <stdio.h>
#include <unistd.h>
#include "arduino.h"
#include "request.h"
#include "callback.h"
#include "arm.h"
#include "io.h"

int main(){
	int speed;
	run_state_t state;
	int dist = 500;
	
	int sw;
    
    if(arduino_arm_open() != 0){
	printf("armが正常にセットアップ出来ませんでした。\n");
	return -1;
    }
    if(io_open() != 0){
        printf("タッチセンサが正常にセットアップ出来ませんでした。\n");
        return -1;
    }
	
	if(arduino_open() != 0) return -1;
	
	if(callback_set() != 0){
        printf("強制停止ボタンが正常にセットアップ出来ませんでした。\n");
        return -1;
    }
	
	sleep(2);
	/*
	printf("speed? [cm/s]\n");
	scanf("%d",&speed);*/

	speed = 30;
	linetrace(speed, dist);
	
	while(1){
		request_get_runmode(&state, &speed, &dist);
		if( state == STP ) break;
	}

	sleep(8);

    while(1){
	io_get_sw(&sw);//タッチセンサの値を取得
	printf("switch = %d\n", sw);

        if(sw == 0){//タッチセンサが押されたらアームを動かす
            printf("armを動かします。\n");
            
            osu(1);
            sleep(3);
            osu(2);
        }
	usleep(100 * 1000);
    }

	arduino_close();
	return 0;
}
